/*



	Programma per listare le api del kernel di NT
	usando il Kernel Driver TabApi.sys
	Per caricare dinamicamente il driver uso la stessa tecnica
	di instdrv del DDK

	Autore: Devil (SPP Member)

	Data: 7 Giugno 2000


*/

#include <windows.h>
#include <stdio.h>
#include <winioctl.h>
#include "TabApi.h"

#define NOMEDRIVER "TabApi"



//
// Prototipi
//
static VOID ErrorMessage(LPTSTR lpOrigin,DWORD dwMessageId);

BOOL InstallDriver(IN SC_HANDLE  SchSCManager,IN LPCTSTR DriverName,IN LPCTSTR ServiceExe);
BOOL RemoveDriver(IN SC_HANDLE  SchSCManager,IN LPCTSTR DriverName);
BOOL StartDriver(IN SC_HANDLE SchSCManager,IN LPCTSTR DriverName);
BOOL StopDriver(IN SC_HANDLE SchSCManager,IN LPCTSTR DriverName);



BOOL InstallDriver(IN SC_HANDLE  SchSCManager,IN LPCTSTR DriverName,IN LPCTSTR ServiceExe)

{
    SC_HANDLE  schService;



    schService = CreateService (SchSCManager,          
                                DriverName,           
                                DriverName,           
                                SERVICE_ALL_ACCESS,    
                                SERVICE_KERNEL_DRIVER, 
                                SERVICE_DEMAND_START,  
                                SERVICE_ERROR_NORMAL,  
                                ServiceExe,            
                                NULL,                  
                                NULL,                  
                                NULL,                  
                                NULL,                  
                                NULL                  
                                );

    if (schService == NULL)
    {
        ErrorMessage("CreateService",GetLastError());
        return FALSE;
    }
    CloseServiceHandle (schService);
    return TRUE;
}



BOOL RemoveDriver(IN SC_HANDLE  SchSCManager,IN LPCTSTR DriverName)
{
    SC_HANDLE  schService;
    BOOL       ret;

    schService = OpenService (SchSCManager,
                              DriverName,
                              SERVICE_ALL_ACCESS
                              );

    if (schService == NULL)
    {
        ErrorMessage("OpenService", GetLastError());
        return FALSE;
    }

    ret = DeleteService (schService);

    if (!ret)
    {
        ErrorMessage("RemoveDriver", GetLastError());
    }
    CloseServiceHandle (schService);
    return ret;
}


BOOL StartDriver(IN SC_HANDLE SchSCManager,IN LPCTSTR DriverName)
{
    SC_HANDLE  schService;
    BOOL       ret;

    schService = OpenService (SchSCManager,
                              DriverName,
                              SERVICE_ALL_ACCESS
                              );

    if (schService == NULL)
    {
        ErrorMessage("OpenService", GetLastError());
        return FALSE;
    }

    ret = StartService (schService,    // service identifier
                        0,             // number of arguments
                        NULL           // pointer to arguments
                        );
    if (!ret)
    {
		ErrorMessage("StartService",GetLastError());
    }
    CloseServiceHandle (schService);
    return ret;
}



BOOL StopDriver(IN SC_HANDLE SchSCManager,IN LPCTSTR DriverName)
{
    SC_HANDLE       schService;
    BOOL            ret;
    SERVICE_STATUS  serviceStatus;

    schService = OpenService (SchSCManager,
                              DriverName,
                              SERVICE_ALL_ACCESS
                              );

    if (schService == NULL)
    {
        ErrorMessage("OpenService", GetLastError());
        return FALSE;
    }

    ret = ControlService (schService,
                          SERVICE_CONTROL_STOP,
                          &serviceStatus
                          );
    if (!ret)
    {
        ErrorMessage("StopService",GetLastError());
    }

    CloseServiceHandle (schService);

    return ret;
}


VOID __cdecl main(VOID)
{
	HANDLE hDevice;
	DWORD dwBytesWritten;
	DWORD dwErrorCode;
	InfoTabella Tabella;
	DWORD Quanti,outputlength;
    SC_HANDLE   schSCManager;
	char * pPath;

	dwBytesWritten=GetCurrentDirectory(0,NULL);
	pPath=malloc(dwBytesWritten+strlen(NOMEDRIVER)+7);
	dwBytesWritten=GetCurrentDirectory(dwBytesWritten,pPath);
	strcat(pPath,"\\");
	strcat(pPath,NOMEDRIVER);
	strcat(pPath,".sys");


    schSCManager = OpenSCManager (NULL,                 // machine (NULL == local)
                                  NULL,                 // database (NULL == default)
                                  SC_MANAGER_ALL_ACCESS // access required
                                  );

	if (InstallDriver(schSCManager,NOMEDRIVER,pPath))
	{
		// Il driver viene aperto come un qualunque file.
		// i progettisti di NT si sono finalmente uniformati
		// allo standard Unix, almeno rigurardo a questa cosa

		if (StartDriver(schSCManager,NOMEDRIVER))
		{
			hDevice = CreateFile(
					"\\\\.\\TabApi",
					GENERIC_WRITE,
					0,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,
					NULL );

			if( hDevice == INVALID_HANDLE_VALUE )
			{
				dwErrorCode = GetLastError();
				ErrorMessage( "CreateFile", dwErrorCode );
				free(pPath);
				StopDriver(schSCManager,NOMEDRIVER);
				RemoveDriver(schSCManager,NOMEDRIVER);
			    CloseServiceHandle (schSCManager);
				ExitProcess( dwErrorCode );
			}

	
			// Invio il codice di controllo al mio driver passandogli un buffer da riempire
	
			outputlength=sizeof(Tabella);
			Tabella.Servizio=210;
			if (DeviceIoControl(hDevice,IOCTL_TABAPI_READBUFFER,&Tabella,outputlength,&Tabella,outputlength,&Quanti,NULL))
			{
				unsigned int i;
				printf("Numero Totale dei Servizi Kernel :%d\n",Tabella.NumServizi);      
				printf("Indirizzo Tabella Servizi %04x:%x\n",Tabella.SegmentoTabella,Tabella.IndirizzoTabellaServizi);
				printf("Indirizzo tabella Parametri %04x:%x\n",Tabella.SegmentoTabella,Tabella.IndirizzoTabellaParametri);
				printf("--------------------------------------------------------------\n");
				printf("Servizio\tSeg:Offset\tNumParametri\n");
				printf("--------------------------------------------------------------\n");
				for(i=0;i<Tabella.NumServizi;i++)
				{
					outputlength=sizeof(Tabella);
					Tabella.Servizio=i;
					DeviceIoControl(hDevice,IOCTL_TABAPI_READBUFFER,&Tabella,outputlength,&Tabella,outputlength,&Quanti,NULL);
					printf("   %d\t      %04x:%x    \tBytes=%d\n",i,Tabella.Segmento,Tabella.Offset,Tabella.Parametro);
				}

			}
			else
			{
				dwErrorCode = GetLastError();
				ErrorMessage( "DeviceIOControl", dwErrorCode );	

			}
			free(pPath);
			CloseHandle( hDevice );
			StopDriver(schSCManager,NOMEDRIVER);
			RemoveDriver(schSCManager,NOMEDRIVER);

		}
		else
		{
			free(pPath);

		}
	}
    CloseServiceHandle (schSCManager);

}


//
// La routine converte un codice di errore
// in un messaggio di testo... come da standard Microsoft
//
static VOID ErrorMessage(LPTSTR lpOrigin,DWORD dwMessageId)
{
	LPTSTR msgBuffer;               
	DWORD cBytes;                   

	cBytes = FormatMessage(
				FORMAT_MESSAGE_FROM_SYSTEM |
				FORMAT_MESSAGE_ALLOCATE_BUFFER,
				NULL,
				dwMessageId,
				MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),
				(TCHAR *)&msgBuffer,
				500,
				NULL );
	if( msgBuffer ) {
		msgBuffer[ cBytes ] = TEXT('\0');
		printf( "Error: %s -- %s\n", lpOrigin, msgBuffer );
		LocalFree( msgBuffer );
	}
	else {
		printf( "FormatMessage error: %d\n", GetLastError());
	}
}
